// touch hardware config
// TP_CS    PB4
// TP_INT   PD3    INT1
// SCK      PB7    SPI_SCK
// MOSI     PB5    SPI_MOSI
// MISO     PB6    SPI_MISO

/*
7  6 - 4  3      2     1-0
s  A2-A0 MODE SER/DFR PD1-PD0
*/
#define TOUCH_MSR_Y  0xD0   // read X koordination 
#define TOUCH_MSR_X  0x90   // read Y koordination 

//-----------------------------------------------------
#include <avr/io.h>
#include <avr/interrupt.h>
#include "mmc_sd.h"
#include "int.h"
#include "delay.h"
#include "ili_lcd_general.h"
#include "lcd_api.h"
#include <stdio.h>
#include "i2cmaster.h"
uint8_t Key;

void touch_init(void)
{
    // CS PORT init
    DDRB |= 1<<PB4;
    SPI_CS_Deassert();

//    SPI_Init();

    DDRD &= ~(1<<PD3);
    Init_INT0();

    // enable touch int
    SPI_WriteByte(0<<7);
}

char str_buf[100];
volatile uint8_t touch_int_flag = 0;

unsigned char address;
unsigned char data = 0xFF ;


void show_toch(void)
{
    uint16_t x,y,temp1,temp2,temp3,temp4;
    uint8_t t,tk,pKey,ppKey;
   
    t = 1;
    x = 1;
    y = 1;
    while(t)
   {
            
    SPI_CS_Assert();
    SPI_WriteByte(TOUCH_MSR_X);                      /* read X */
    x = SPI_WriteByte(0x00)<<4;                      /* read MSB bit[11:8] */
    x |= ((SPI_WriteByte(TOUCH_MSR_Y)>>4)&0x0F );    /* read LSB bit[7:0] */
    y = SPI_WriteByte(0x00)<<4;                      /* read MSB bit[11:8] */
    y |= ((SPI_WriteByte(0x00)>>4)&0x0F );           /* read LSB bit[7:0] */
      temp2 = temp1;
      temp1 = x;
      if((temp1==x)&&(temp2==temp1))
        {
        temp4 = temp3;
        temp3 = y;
        if((temp3==y)&&(temp4==temp3))t = 0;
        }
        
            
        
    }
   
   
    LCD_write_english_string(0,0,"touch:",RED,BLACK);
    sprintf(str_buf,"read X:%04d",x);
    LCD_write_english_string(0,20,str_buf,GREEN,BLACK);
    sprintf(str_buf,"read Y:%04d",y);
    LCD_write_english_string(0,40,str_buf,GREEN,BLACK);
    t = 1;
    tk = 0;
    
       while(t){   
                            if((127<y)&&(y<744))
                             {  if((127<x)&&(x<576))Key = 11,LCD_Rect(182,218,7,73,YELLOW),LCD_write_english_string(20,194,"SW 1",RED,BLACK);}                             
                            if((254<y)&&(y<704))
                             {   if((608<x)&&(x<992))Key = 12,LCD_Rect(182,218,87,153,YELLOW),LCD_write_english_string(100,194,"SW 2",RED,BLACK);}
                            if((127<y)&&(y<704))
                             {   if((1000<x)&&(x<1568))Key = 13,LCD_Rect(182,218,167,233,YELLOW),LCD_write_english_string(180,194,"SW 3",RED,BLACK);}
                            if((127<y)&&(y<704))
                             {   if((1600<x)&&(x<1888))Key = 14,LCD_Rect(182,218,247,313,YELLOW),LCD_write_english_string(260,194,"SW 4",RED,BLACK);}
                            if((768<y)&&(y<1536))
                             {   if((127<x)&&(x<592))Key = 21,LCD_Rect(102,138,7,73,YELLOW),LCD_write_english_string(20,114,"SW 5",RED,BLACK);}
                            if((768<y)&&(y<1104))
                             {   if((608<x)&&(x<992))Key = 22,LCD_Rect(102,138,87,153,YELLOW),LCD_write_english_string(100,114,"SW 6",RED,BLACK);}
                            if((736<y)&&(y<1128))
                             {   if((1007<x)&&(x<1568))Key = 23,LCD_Rect(102,138,167,233,YELLOW),LCD_write_english_string(180,114,"SW 7",RED,BLACK);}
                            if((800<y)&&(y<1216))
                             {   if((1616<x)&&(x<2032))Key = 24,LCD_Rect(102,138,247,313,YELLOW),LCD_write_english_string(260,114,"SW 8",RED,BLACK);}
                            if((1536<y)&&(y<1616))
                             {   if((127<x)&&(x<511))Key = 31;}
                             //delay_ms(500);}.
                            if((1536<y)&&(y<1856))
                             {   if((608<x)&&(x<992))Key = 32;}
                             //delay_ms(500).;}
                            if((1128<y)&&(y<1616))
                             {   if((1007<x)&&(x<1600))Key = 33;}
                             //delay_ms(500).;}
                            if((1234<y)&&(y<1600))
                             {   if((1600<x)&&(x<2016))Key = 34;}
                             //delay_ms(500).;}  
                            if((1616<y)&&(y<1985))
                             {   if((127<x)&&(x<499))Key = 41;}
                             //delay_ms(500).;}
                            if((1616<y)&&(y<1985))
                             {   if((511<x)&&(x<992))Key = 42;}
                             //delay_ms(500).;}
                            if((1600<y)&&(y<1985))
                             {   if((1002<x)&&(x<1536))Key = 43;}
                             //delay_ms(500).;}
                            if((1600<y)&&(y<1985))
                             {   if((1568<x)&&(x<2000))Key = 44;}
                             //delay_ms(500).;}
                            
                            ppKey = pKey;
                            pKey = Key;
                            
                                if((Key==pKey)&&(pKey==ppKey))
                                {
                    

                                    LCD_write_english_string(0,60,"Key:",RED,BLACK);
                                    sprintf(str_buf,"read Key:%02d",Key);
                                    LCD_write_english_string(0,80,str_buf,GREEN,BLACK);
                                        Key = 0;pKey =0;ppKey =0;
                                                t=0;
                                            
                                }

if(Key>0){
        
           
            
    SPI_WriteByte(1<<7);
    
              switch (Key)
                    {uint8_t z = 0;
                        
                    case 11:
                        //delay_ms(500);
                                
                             if(z==1)LCD_Rect(186,222,11,77,GREEN),data&= ~(1<<0),z=0;
                             else(LCD_Rect(186,222,11,77,MAGENTA)),data|= (1<<0),z=1;
                             SPI_WriteByte(0<<7);
                                
                        break;

                    case 12:
                        //delay_ms(500);
                                
                             if(z==1)LCD_Rect(186,222,91,157,GREEN),data&= ~(1<<1),z=0;
                             else(LCD_Rect(186,222,91,157,MAGENTA)),data|= (1<<1),z=1;
                             SPI_WriteByte(0<<7); 
                        break;

                    case 13:
                        //delay_ms(500);
                             if(z==1)LCD_Rect(186,222,171,237,GREEN),data&= ~(1<<2),z=0;
                             else(LCD_Rect(186,222,171,237,MAGENTA)),data|= (1<<2),z=1;
                             SPI_WriteByte(0<<7); 
                        break;

                    case 14:
                        //delay_ms(500);
                             if(z==1)LCD_Rect(186,222,251,317,GREEN),data&= ~(1<<3),z=0;
                             else(LCD_Rect(186,222,251,317,MAGENTA)),data|= (1<<3),z=1;
                             SPI_WriteByte(0<<7); 
                        break;

                    case 21:
                        //delay_ms(500);
                             if(z==1)LCD_Rect(106,142,11,77,GREEN),data&= ~(1<<4),z=0;
                             else(LCD_Rect(106,142,11,77,MAGENTA)),data|= (1<<4),z=1;
                             SPI_WriteByte(0<<7); 
                        break;

                    case 22:
                        //delay_ms(500);
                             if(z==1)LCD_Rect(106,142,91,157,GREEN),data&= ~(1<<5),z=0;
                             else(LCD_Rect(106,142,91,157,MAGENTA)),data|= (1<<5),z=1;
                             SPI_WriteByte(0<<7); 
                        break;

                    case 23:
                        //delay_ms(500);
                             if(z==1)LCD_Rect(106,142,171,237,GREEN),data&= ~(1<<6),z=0;
                             else(LCD_Rect(106,142,171,237,MAGENTA)),data|= (1<<6),z=1;
                             SPI_WriteByte(0<<7); 
                        break;

                    case 24:
                        //delay_ms(500);
                             if(z==1)LCD_Rect(106,142,251,317,GREEN),data&= ~(1<<7),z=0;
                             else(LCD_Rect(106,142,251,317,MAGENTA)),data|= (1<<7),z=1;
                             SPI_WriteByte(0<<7); 
                        break;
                    }
/***hier zum Test auskommentieren(jeweils" / "am Ende bzw. Anfang entfernen ****************/
                   // DISEN_245;                // CMOS_EN = 0
                    i2c_start(0x40);
                    i2c_write( data );
                    i2c_stop();
/***und neu kompilieren. Zum Betrieb der TWI-Karte die beiden Kommentar-Lines lschen*******/  
                    sprintf(str_buf,"write data:%03d",data);
                    LCD_write_english_string(100,20,str_buf,GREEN,BLACK);
          }      
        }
     delay_ms(1000);
    SPI_WriteByte( 0<<7 ); /* enable interrupt */
    SPI_CS_Deassert();
    
    // enable int
    touch_int_flag = 0;
    GICR  |= (1<<INT1) ;//
    
}

SIGNAL( SIG_INTERRUPT1 )
{
    // disable int
    //cli();
    GICR  &= ~(1<<INT1) ;//
    touch_int_flag = 1;
    
}


