#include <avr/io.h>
#include <avr/interrupt.h>
#include "ILI9331.h"
#include "ov7670.h"
#include "int.h"
#include <util/delay.h>
#include "FAT.h"
#include "config.h"
#include "mmc_sd.h"

unsigned int image_count = 0, image_all = 0;



extern uint16 SectorsPerClust;

extern uint8  FAT32_Enable;

void disp_image(void)
{
    WORD count= 1, i =0;
    uint8 *buffer;
    uint8 type = 0, x = 0, rgb = 0, first = 0, color_byte = 0, byte1 = 0, byte2 = 0, byte3 = 0;
    uint16 y = 0, color = 0, tmp_color = 0;
    uint32 p;				//cluster
    type = 1;
	
	// struct FileInfoStruct FileInfo;
    struct direntry BMPInfo;	//the bmp file item which will be played

    LCD_WR_REG(0x0050, 0);		// horizontal GRAM start point
    LCD_WR_REG(0x0051, 239);	// horizontal GRAM end point
    LCD_WR_REG(0x0052, 0);		// vertical GRAM start point
    LCD_WR_REG(0x0053, 319);	// vertical GRAM end point

    if(image_all == 0)   
    {
        image_count =  0;
        byte1 = Search(&BMPInfo, &image_count, &type);
        image_all = image_count;
        image_count = 1;

        /*
        image_count = 0 ;
        Search(&BMPInfo, &image_count, &type);
        image_all = image_count ;
        GUI_sprintf_chartohex(10, 300, 0x00, 0xffff, 0x0000);
        GUI_sprintf_chartohex(30, 300, image_count, 0xffff, 0x0000);
        GUI_sprintf_chartohex(60, 300, image_all, 0xffff, 0x0000);
        */
    }
    else
    {
        byte1 = Search(&BMPInfo, &image_count, &type);
    }



    p = BMPInfo.deStartCluster + (((uint32)BMPInfo.deHighClust) << 16);	// read the first cluster of the file

    x = 0;
    y = 319;
    rgb = 0;
    count = 0;
    first = 0;
    buffer = malloc(512);
    while(1)
    {
        i = 0;

        for(; i < SectorsPerClust; i++ )      
        {

            FAT_LoadPartCluster(p, i, buffer);	//read a sector

            if(i == 0 && first == 0)
            {
                count = buffer[0x0a];
                color_byte = buffer[0x1c] / 8;
                first = 1;
            }
            else
            {
                count = 0;
            }

            while(count < 512) 
            {

                if(color_byte == 3)   // 24 bit image
                {
                    switch (rgb)
                    {
                    case 0:
                        tmp_color = buffer[count] >> 3;
                        color |= tmp_color;
                        break;

                    case 1:
                        tmp_color = buffer[count] >> 2 ;
                        tmp_color <<= 5;
                        color |= tmp_color;
                        break;

                    case 2:
                        tmp_color = buffer[count] >> 3;
                        tmp_color <<= 11;
                        color |= tmp_color;
                        break;
                    }

                    rgb++;
                }
                else
                {
                    if(color_byte == 2)  // 16 bit image
                    {
                        switch (rgb)
                        {
                        case 0:
                            byte1 = buffer[count];
                            break;

                        case 1:
                            color = buffer[count];
                            color <<= 8;
                            color |= byte1;
                            break;
                        }
                        rgb ++;
                    }
                    else
                    {
                        if(color_byte == 4) // 32 bit image
                        {
                            switch (rgb)
                            {
                            case 0:
                                byte1 = buffer[count];
                                break;

                            case 1:
                                byte2 = buffer[count];
                                break;

                            case 2:
                                byte3 = buffer[count];
                                break;

                            case 3:
                                tmp_color = byte1 >> 3;
                                color |= tmp_color;
                                tmp_color = byte2 >> 2;
                                tmp_color <<= 5;
                                color |= tmp_color;
                                tmp_color = byte3 >>3;
                                tmp_color <<= 11;
                                color |= tmp_color;
                                break;
                            }
                            rgb++;
                        }
                    }
                }

                count++;

                if(rgb == color_byte)
                {
                    // GUI_Point(x, y, color);

                    LCD_WR_REG(0x0020, 239 - x);	// Horizontal GRAM start point of LCD cursor
                    LCD_WR_REG(0x0021, 319 - y); 	// vertical GRAM start point of LCD cursor

                    LCD_WR_REG16(0x0022);
                    LCD_WR_DATA16(color);

                    color = 0x00;
                    x++;
                    if(x >= 240)
                    {
                        y--;
                        if(y<=0)
                        {
                            free(buffer);
                            return;
                        }
                        x = 0;
                    }
                    rgb = 0;
                }
            }
        }  // end of reading a cluster

        free(buffer);
        p=FAT_NextCluster(p);		//read next cluster
        buffer=malloc(512);

        if(p == 0x0fffffff || p == 0x0ffffff8 || (FAT32_Enable == 0 && p == 0xffff))	//no more cluster
        {
            free(buffer);
            return;
        }
    }

    free(buffer);
}



int main(void)
{
    unsigned char retry = 0;

    EXCLK_DDR |= 1 << EXCLK_BIT;		// set en_exclk as output
    HC245_OE_DDR |= 1 << HC245_OE_BIT;	// set en_245 as output

    DISEN_EXCLK;	
    DISEN_245;

    DATA_OUPUT(); 
    LCD_Init();
	
    //GUI_Point(0, 0, 0xffff);
    LCD_write_english_string(20, 130, "www.MyCool.eu", RED, BLACK);
    LCD_write_english_string(20, 150, __DATE__, GREEN, BLACK);
    LCD_write_english_string(20, 170, "Atmega32 & ili9325 fuer OV7670 REV4.1", GREEN, BLACK);
    LCD_write_english_string(20, 190, "TF Card Init......", BLUE, BLACK);

    MMC_SD_Init();
    _delay_ms(100);

    while(MMC_SD_Reset()&(retry < 5))					//sd card initialize
    {
        retry++;
        if(retry > 4)
        {
            LCD_write_english_string(20, 190, "TF Card Init...ING", BLUE, BLACK);
            retry = 21;
        }

    }
    if(retry < 20) 
		LCD_write_english_string(20, 190, "TF Card Init....OK", BLUE, BLACK);

    if(retry < 20)
		LCD_write_english_string(20, 210, "FAT Init......", BLUE, BLACK);
		
    while(FAT_Init()&(retry < 20))	//initialize file system  FAT16 and FAT32 are supported
    {
	
    }

    if(retry < 20)
		SearchInit();  

    if(retry < 20) 
		LCD_write_english_string(20, 210, "FAT Init....OK", BLUE, BLACK);


    if(retry>20)
		LCD_write_english_string(20, 210, "OV7670 Init......", BLUE, BLACK);

    while((1 != OV7670_init()) & (retry > 20));
    
	//_delay_ms(1000);
    if(retry > 20)
		LCD_write_english_string(20, 210, "OV7670 Init  0K  ", RED, BLACK);
		
    _delay_ms(200);
	
    if(retry > 20)
		LCD_Clear(0);
    if(retry > 20)
		DATA_INPUT();
    if(retry > 20)
		Init_INT0();

    while(1)
    {
        if(retry < 20)
        {
            disp_image() ;
            _delay_ms(1000);
            if(image_count < image_all)
            {
                image_count++;
            }
            else
            {
                image_count = 1;
            }
        }
    }
}

