#include <avr/io.h>
#include <util/delay.h>
#include <avr/eeprom.h>

#include "ili_lcd_general.h"
#include "lcd_api.h"

// touch init
extern void touch_init(void);
extern void show_toch(void);

extern volatile uint8_t touch_int_flag;


int main(void)
{
    DDRB |= (1<<PB0); // set en_exclk as output
    DDRD |= (1<<PD6); // set en_245 as output

    PORTB &= ~(1<<PB0); //DISEN_EXCLK;
    PORTD |=  (1<<PD6); //DISEN_245;  

    
    LCD_Init();

    LCD_write_english_string(20,130,"www.MyCool.eu",RED,BLACK);
    LCD_write_english_string(20,150,"use avrgcc:",GREEN,BLACK);
    LCD_write_english_string(20+8*12,150,__AVR_LIBC_DATE_STRING__,GREEN,BLACK);
    LCD_write_english_string(20,170,__DATE__,GREEN,BLACK);
    LCD_write_english_string(20,190,"Atmega32 & ili9325 fuer OV7670 REV4.1",GREEN,BLACK);

    touch_init();

    touch_int_flag = 1;

    while(1)
    {
        if( touch_int_flag )
        {
            show_toch();
        }
    }
}

